/* ѹ򷸿ȤϢΩ켡 */
/* Ux=b  */
void solve_uxb(int n, matrix u, vector b)
{
  int i, j;
  for (i = n; i >= 1; i--) {
    for (j = i + 1; j <= n; j++)
      b[i] -= u[i][j] * b[j];
    b[i] /= u[i][i];
  }
}

/* L^T x=b   solve_uxb()  u[i][j]  L[j][i]  */
void solve_ltxb(int n, matrix L, vector b)
{
  int i, j;
  for (i = n; i >= 1; i--) {
    for (j = i + 1; j <= n; j++)
      b[i] -= L[j][i] * b[j];
    b[i] /= L[i][i];
  }
}

/* Lx=b  */
void solve_lxb(int n, matrix L, vector b)
{
  int i, j;
  for (i = 1; i <= n; i++) {
    for (j = 1; j < i; j++)
      b[i] -= L[i][j] * b[j];
    b[i] /= L[i][i];
  }
}

/* U^T x=b  */
void solve_utxb(int n, matrix U, vector b)
{
  int i, j;
  for (i = 1; i <= n; i++) {
    for (j = 1; j < i; j++)
      b[i] -= U[j][i] * b[j];
    b[i] /= U[i][i];
  }
}
