// Ux=b 
void solve_uxb(int n, Matrix u, Vector b)
{
  for (int i = n; i >= 1; i--) {
    for (int j = i + 1; j <= n; j++)
      b[i] -= u[i][j] * b[j];
    b[i] /= u[i][i];
  }
}

// Lx=b 
void solve_uxb(int n, Matrix L, Vector b)
{
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j < i; j++)
      b[i] -= L[i][j] * b[j];
    b[i] /= L[i][i];
  }
}
